Compile with clang: Cannot compile with -flto -fvisibility=hidden

11/12/2022 01:36 AM - steakknife (Barry Allard)

Status: Feedback   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.1.2p20 (2022-04-12 revision

4491bb740a) [x86_64-linux]

Backport: 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1:

UNKNOWN

Description

Environment

CentOS 9 Stream x86_64

96 threads

96 GiB RAM

140 GiB SSD storage

Reproduction

sudo dnf install -y yum-utils

sudo yum-config-manager --enable crb

sudo dnf install -y \

  make bc binutils-gold mold patch git bison xz autoconf automake m4 libtool pkg-config perl-inter

preter \

  gmp-devel openssl-devel readline-devel libyaml-devel gdbm-devel zlib-devel libffi-devel \

  ncurses-devel readline-devel glibc-static glibc-devel llvm-toolset

LINKER=gold # also tried lld, bfd, and mold

FLAGS=''

LINKFLAGS="-fuse-ld=$LINKER -flto -fvisibility=hidden" # works without -flto -fvisibility=hidden

EXE_LINKFLAGS=''

export \

  CC=clang \

  CXX=clang++ \

  LD=$LINKER \

  CPPFLAGS="$FLAGS" \

  CFLAGS="$FLAGS" \

  CXXFLAGS="$FLAGS" \

  DCFLAGS="$FLAGS" \

  XCFLAGS="$FLAGS" \

  MJIT_CFLAGS="$FLAGS" \

  DLDFLAGS="$FLAGS $LINKFLAGS" \

  LDFLAGS="$FLAGS $LINKFLAGS" \

  XLDFLAGS="$FLAGS $LINKFLAGS $EXE_LINKFLAGS"

./configure --disable-install-doc --enable-shared && \

  make -j && \

  make test && \

  sudo make install

 

Expected result

Installs ruby.

Actual result

Hangs at linking conftest with 1 process remaining but it never finishes (waiting hours).
/usr/bin/ld -export-dynamic --build-id --eh-frame-hdr -m elf_x86_64 -export-dynamic -dynamic-linke

r /lib64/ld-linux-x86-64.so.2 -o conftest /lib/../lib64/crt1.o /lib/../lib64/crti.o /opt/rh/gcc-to

olset-12/root/usr/lib/gcc/x86_64-redhat-linux/12/crtbegin.o -L. -L../.. -L. -L/opt/rubies/ruby-3.1

.2/lib -L/opt/rh/gcc-toolset-12/root/usr/lib/gcc/x86_64-redhat-linux/12 -L/opt/rh/gcc-toolset-12/r

oot/usr/lib/gcc/x86_64-redhat-linux/12/../../../../lib64 -L/lib/../lib64 -L/usr/lib/../lib64 -L/li

b -L/usr/lib -plugin /usr/bin/../lib64/LLVMgold.so -plugin-opt=mcpu=x86-64 -plugin-opt=O3 -plugin-

opt=-debugger-tune=gdb /tmp/conftest-b32079.o -export-dynamic --no-as-needed -rpath /opt/rubies/ru

by-3.1.2/lib -lruby-static -lz -lpthread -lrt -lrt -lgmp -ldl -lcrypt -lm -lm -lc -lgcc --as-neede

d -lgcc_s --no-as-needed -lc -lgcc --as-needed -lgcc_s --no-as-needed /opt/rh/gcc-toolset-12/root/

usr/lib/gcc/x86_64-redhat-linux/12/crtend.o /lib/../lib64/crtn.o

History

#1 - 11/12/2022 02:22 AM - steakknife (Barry Allard)

-flto itself works. -fvisibility= is needed for other -fsanitize= options.

#2 - 11/24/2022 05:49 PM - alanwu (Alan Wu)

- Status changed from Open to Feedback

Since the linker hangs, I don't think there is much we can do on our end.

Assuming Clang mimics GCC I think LD should be set to clang for LTO.

From GCC's man page:

The important thing to keep in mind is that to enable link-

time optimizations you need to use the GCC driver to perform the link step.
